/*
 *		DANS UN LIEU INCONNU
 *
 *	essai sur la vision interieur d'un batiment
 *	-------------------------------------------
 *
 *	Tout cela mérite une meilleure paramétrisation !
 */

/*    ======================================================    */
/*
 *	quelques parametres
 */

/* position colonne_coin + clocheton */
#declare dX_cc_coin = Sz_X - 3.60;
#declare dZ_cc_coin = Sz_Z - 7.70;

/* controle position traverses / lustres / cubes / piliers */
#local Z_cubes = 18.88;

#local Y_lustre =  9.70;		// hauteur
#local Z_lustre = 11.40;

/*    ======================================================    */
/*
 *	le corps principal du batiment
 */

#declare Batiment_0 = object
{
#local  X2 = Sz_X+E_mur;
#local  Z2 = Sz_Z+E_mur;
#local  X3 = X2 + 0.17;
#local  Z3 = Z2 + 0.17;
difference {
	union	{
		box { <-X2, -1, -Z2>,   < X2, Sz_Y+E_mur,  Z2> }
		box { <-X3, -1, -Z3>, < X3, 2.05,  Z3> }
		}
	/* decoupe de l'interieur */
	box {	<-Sz_X, -0.2, -Sz_Z>, <Sz_X, Sz_Y, Sz_Z> }
	/* ouverture du plafond */
	box { <-Ouv_X, Sz_Y-1, -Ouv_Z>, <Ouv_X, Sz_Y+1, Ouv_Z> }
	}
}
/*    ------------------------------------------------------    */
/*
 *		la grande voute zarbi
 */

#declare Support_Zarbi = object
{
#local H1 = 3.80;
#local H2 = H1 + 0.40;
#local RA = 0.15;
merge	{
	cylinder { <0, 0, 0>, <0, H1, 0>, RA }
	cone { <0, H1, 0>, RA, <0, H2, 0>, 0.00001 }
	}
}
#declare Les_Supports_Zarbis = object
{
union	{
	#for (foo, 1, Sz_Z-2, 2.00)
	  object { Support_Zarbi translate <0, Sz_Y, -foo> }
	  object { Support_Zarbi translate <0, Sz_Y,  foo> }
	#end 
	}
texture { MON_VERT_INDUS }
}

#declare Voute_Zarbi = object
{
difference {
	#local Ez = Ouv_Z + 1.6;
	cylinder { <0, 0, -Ez>, <0, 0, Ez>,       R_v_zarb }
	#local Oz = Ouv_Z + 0.8;
	cylinder { <0, 0, -Oz>, <0, 0, Oz>,       R_v_zarb-0.20 }
	cylinder { <0, 0, -Sz_Z>, <0, 0, Sz_Z>,   R_v_zarb-2.50 }
	box { <-35, -20, -50>, <35, 0, 50> }
	}
// scale <1, 0.777, 1>
texture {
	pigment { color Gray50 }
	finish { phong PHONG specular SPECULAR }
	}
}
/*    ------------------------------------------------------    */
/* bloc + voute */
#declare Batiment_1 = object
{
union	{
	/* dummy object for make povray happy */
	sphere { 0, 0.00000001 }
	#local E = 8.50;
	object { Batiment_0 }
	// object { Les_Supports_Zarbis  translate -E*x }
	// object { Les_Supports_Zarbis  translate  E*x }
	// object { Voute_Zarbi translate y*(3.00+Sz_Y) }
	// object { Verriere_0  rotate y*90 translate y*(0.50+E_mur+Sz_Y) }
	#undef E
	}
}

/*    ------------------------------------------------------    */
/*
 *	Des découpes pour faire des fenêtres
 */
#declare Decoupe_Fenetre_0 = object
{
#local HF = 6.45;
#local DF = 1.15;		// largeur*0.5

merge {
	box { <-DF, 0, -1>,<DF, HF, 1> }
	#local E  = DF * 0.60;
	#local H2 = HF + 0.59;
	#local H3 = H2 + 0.917;
	#local H4 = H3 + 0.817;
	#local D2 = DF * 0.31;
	#local D3 = DF * 0.76;
	cylinder { <-E, H4, -1>, <-E, H4, 1>, D2 }
	cylinder { < E, H4, -1>, < E, H4, 1>, D2 }
	cylinder { < 0, 0, -1>, < 0, 0, 1>, D3 scale <1, 1.92, 1> translate y*HF }
	// cylinder { <-E, H2, -1>, <-E, H2, 1>, D2 }
	// cylinder { < E, H2, -1>, < E, H2, 1>, D2 }
	}
}
/*    ------------------------------------------------------    */
/*    new 26 mai 2022 */
#declare Decoupe_Fenetre_1 = object
{
#local R = 1.42;
#local S = 3.24;
merge {
	cylinder { <0, 0, -2>, <0, 0, 2>, R scale <S, 1, 1> }
	cylinder { <0, 0, -2>, <0, 0, 2>, R scale <1, S, 1> }
	}
rotate z*45
#undef S
#undef R
}

/*    ------------------------------------------------------    */
#declare Decoupe_Porte_0 = object
{
#local HP = 2.58;		// hauteur
#local DP = 2.02;		// dimension porte en largeur
/*
 *	NEED MORE WORK - - - - XXX
 */
merge {
	cylinder { <0, HP, -1>, <0, HP, 1>, DP*0.72 scale <1.2, 1, 1> }
	box { <-DP, 0.001, -1>, <DP, HP, 1> }
	}
}
/*    ------------------------------------------------------    */
/*	nouveau Sat 18 Mar 2023 11:55:42 PM CET
 */

#declare Decoupe_Porte_1 = object
{
#local HP = 7.07;		// hauteur
#local DP = 2.27;		// dimension  en largeur

union	{
	box { <-DP,     0.001, -1>, < DP,     HP, 1> }
	box { < DP*1.1, 1.20,  -1>, < DP*2.3, HP-4.8, 1> }
	box { <-DP*1.1, 1.20,  -1>, <-DP*2.3, HP-4.8, 1> }

	#local d2 = DP * 0.58;
	box { <-d2, -d2, -1>, <d2, d2, 1>
		rotate z*45 scale <1, 1, 1.717> translate y*(HP+2.48) }
	}
}

/*    ======================================================    */
/*
 * nouveau 6 juillet 2022
 *	après une trop longue attente, l'intégration de
 *	la rotonde est enfin en route.
 *
 *	les parametres utilises dans cet objet devraient etre
 *	deduits de la configuration dans 'rotonde.inc'
 */

#declare Decoupe_pour_rotonde = object
{

#local WDR = 6.66;
merge	{
	box { <-WDR, 0, -1>,<WDR, 6.0, 1> }
	cylinder { <0, 0, -1>, <0, 0, 1> WDR scale <1, 0.256, 1> translate y*6.0 }
	}
// XXX neeed more work !	
}

/*    ======================================================    */
/*
 *		Estampage du batiment
 */
#declare Batiment = object
{
difference {
	object { Batiment_1 }
	object { Decoupe_Porte_0 scale <1, 1.44, 1>  translate <-2.95, 0, Sz_Z> }
	object { Decoupe_Porte_0 scale <1, 1.81, 1>  translate < 2.40, 0, Sz_Z> }
	object { Decoupe_Porte_0 scale <1, 1.44, 1>  translate < 8.20, 0, Sz_Z> }

	object { Decoupe_pour_rotonde translate -Sz_Z * z }

	#local PXDF1 = 15.60;
	#local HDF1 = Sz_Y * 0.465;
	object { Decoupe_Fenetre_1 translate <-PXDF1, HDF1, -Sz_Z> }
	object { Decoupe_Fenetre_1 translate < PXDF1, HDF1, -Sz_Z> }
	object { Decoupe_Fenetre_1 translate <-PXDF1, HDF1,  Sz_Z> }
	object { Decoupe_Fenetre_1 translate < PXDF1, HDF1,  Sz_Z> }

#local EZ  = Sz_Z - 1.19;
#local Hf0 = Sz_Y - 9.90;		/* position Y de la fenetre */

#for (foo, -EZ, EZ, 2.65)

	#if (abs(foo) > 3.41)
	/* c'est quel X ? */
	object { Decoupe_Fenetre_0 rotate y*90
				translate <-Sz_X, Hf0, foo> }
	#end

	#if (abs(foo) > 10.25)
	/* c'est quel X ? */
	  object { Decoupe_Fenetre_0 rotate y*90
				translate < Sz_X, Hf0, foo> }
	#end

#end

	/* 24 mai 2022 : on ouvre deux portes coté jardin */
	#local Ezp = 4.75;
	#local Scp = <1.95, 2.60, 1.80> ;
	object { Decoupe_Porte_0 scale Scp rotate y*90
				translate <Sz_X, 0,  Ezp> }
	object { Decoupe_Porte_0 scale Scp rotate y*90
				translate <Sz_X, 0, -Ezp> }

	/* 19 mars 2023 : on ouvre une porte coté annexe */
	object { Decoupe_Porte_1 rotate y*90 translate -x*Sz_X }

	}

texture {
	pigment { color srgb <0.85, 0.85, 0.60> }
	normal { dents 1.10 scale 0.09 }
	finish { phong PHONG specular SPECULAR }
	}

}

/*    ======================================================    */

#declare Frise_A_pointe = object
{
#local ra = 0.045;
merge	{
	sphere { <0, 0.48, 0>, ra*0.717 }
	cone { <0, 0.35, 0>, ra, <0, 0.70, 0>, 0.01 }
	cylinder { <0, 0, 0>, <0, 0.35, 0>, ra }
	}
}
#declare Frise_A = object
{
#local ep2 = 0.02;
#local hp  = 0.24;
union {
	box { <-ep2, 0, -Sz_Z>, <ep2, hp, Sz_Z> }
	#for (foo, -Sz_Z, Sz_Z, 0.50)
	  object { Frise_A_pointe translate z*foo }
	#end
	}
texture {
	pigment { color IndianRed 			}
	finish  { phong PHONG  specular SPECULAR 	}
	}
}
/*    ======================================================    */
#declare Le_Coin_Craignos = object
{
union	{
	object { Barriere rotate y*89 translate  -1.62*z }
	object { Barriere rotate y*92 translate   1.45*z }
	object { Barriere             translate  -1.65*x }
	object { Barriere             translate   1.57*x }
	object { Le_MegaBrotch }
	}
rotate -12*y
}
/*    ------------------------------------------------------    */
/*    ======================================================    */

#declare Pilier_0_a = object
{
union	{
	cylinder { <0, 0, 0>, <0, Sz_Y, 0>, 0.18 }
	cylinder { <0, 0, 0>, <0, 0.80, 0>, 0.43 }
	sphere { 0, 0.42 scale <1, 0.5, 1> translate <0, 0.80, 0> }
	}
texture { GRIS_BROTCH scale 0.14 }
}

#declare Pilier_0_b = object 
{
merge	{
	box { <-0.25, -0.05, -0.85>, <0.25, 0, 0.85> }
	box { <-0.18, -0.12, -0.45>, <0.18, 0, 0.45> }
	}
texture { GRIS_BROTCH scale 0.06 }
}

#declare Pilier_0 = object 
{
union	{
	object { Pilier_0_a }
	object { Pilier_0_b translate y*Sz_Y }
	}
}

/*    ======================================================    */

#declare ColRonde_top = object
{
union {
	cylinder { 0, <0, 0.22, 0>, 0.60 }
	#local E = 0.48;
	#local H = 0.06;
	#for (foo, 0, 360, 18)
	  #local dx = E * sin(radians(foo));
	  #local dz = E * cos(radians(foo));
	  sphere { <dx, H, dz>, 0.13 }
	#end 
	}
texture { T_Stone11 }
}

#local HF = Sz_Y;			/* WTF? XXX */
#declare ColRonde_fut_a = object
{
intersection {
	#local S  = 0.28;
	cylinder { 0, <0, HF, 0>, 0.32 }
	box { <-S, 0, -S>, <S, HF+0.001, S> }
	}
texture { T_Stone12 scale 2.4 }
}

#declare ColRonde_fut_b = object
{
union	{
	#local S  = 0.25;
	cylinder { 0, <0, HF, 0>, 0.08 translate <-S, 0,  0> }
	cylinder { 0, <0, HF, 0>, 0.08 translate < S, 0,  0> }
	cylinder { 0, <0, HF, 0>, 0.08 translate < 0, 0, -S> }
	cylinder { 0, <0, HF, 0>, 0.08 translate < 0, 0,  S> }
	}
texture { T_Stone12 rotate <17, 17, 17> scale 1.3 }
}

#declare ColRonde_fut = object
{
union	{
	object { ColRonde_fut_a }
	object { ColRonde_fut_b }
	}
}

/*    ----    */

#declare ColRonde_bas = object
{
union	{
	difference {
		cylinder { 0, <0, 0.45, 0>, 0.78 }
		torus { 0.78, 0.12 translate y*0.49 }
		}
	cone { <0, 0.44, 0>, 0.45, <0, 0.56, 0>, 0.34 }
	}
texture { T_Stone9 }
}
#declare ColRonde = object
{
union	{
	object { ColRonde_top translate y*(HF-0.22) }
	object { ColRonde_fut }
	object { ColRonde_bas }
	}
}

/*    ======================================================    */

#local R_col_coin = 0.39;

#declare ColCoin_chapiteau = object
{
#local S = R_col_coin * 1.58;
#local K = S + 0.20;
#local sc = <1, 1.47, 1>;
#local dc = 0.27;
#local ds = dc * 0.42;
#local oy = 0.41;
difference {
	box	{ <-S, 0,      -S>, 		<S, 0.55, S> }

	sphere	{ <-S, oy,  0>,    ds }
	sphere	{ < S, oy,  0>,    ds }
	sphere	{ < 0, oy, -S>,    ds }
	sphere	{ < 0, oy,  S>,    ds }

	cylinder { <-K, 0, -K>, <-K, 0,  K>, dc scale sc }
	cylinder { < K, 0, -K>, < K, 0,  K>, dc scale sc }
	cylinder { < K, 0, -K>, <-K, 0, -K>, dc scale sc }
	cylinder { < K, 0,  K>, <-K, 0,  K>, dc scale sc }
	}
texture { T_Stone26 scale 9.3 rotate <17, 28, 39> }
}

#declare ColCoin_base = object
{
#local dcc0 = R_col_coin*2.350;
#local dcc1 = R_col_coin*1.853;
merge	{
	cylinder { <0, 0, 0>, <0, 0.50,      0>, dcc0 }
	cone { <0, 0.50, 0>, dcc0, <0, 0.59,      0>, dcc1 }
	cylinder { <0, 0, 0>, <0, 0.68,      0>, dcc1 }
	}
texture { T_Stone26 scale 7.1 }
}

#declare ColCoin_fut = object
{
#local H1 = 0.96;
#local H2 = 9.25;
#local Bz = 0.075;
difference {
	cylinder { <0, 0, 0>, <0, Sz_Y+0.001, 0>, R_col_coin }
	#for (foo, 0, 360, 20)
		#local RR = R_col_coin + 0.047;
		#local dx = RR * sin(radians(foo));
		#local dz = RR * cos(radians(foo));
		sphere { <dx, H1, dz>, Bz }
		cylinder { <dx, H1, dz>, <dx, H2, dz>, Bz }
		sphere { <dx, H2, dz>, Bz }
	#end
	}
texture { T_Stone26 scale <5.6, 10.10, 5.4> }
}

#declare ColCoin = object
{
merge  {
	object   { ColCoin_chapiteau  translate y*(Sz_Y-0.55)    }
	object   { ColCoin_fut                                   }
	object   { ColCoin_base                                  }
	}
}

/*    ======================================================    */
/*
 *    nouveau 3 fevrier 2022, au 64 rue Ernest Renan
 */
#declare Les_Piliers = object
{
union {
	/* exterieur sur l'axe des Z */
	#local EX = Ouv_X + 0.62;		// XXX 6.54;
	#local EZ = Z_cubes;
	object { Pilier_0 translate <-EX, 0,-EZ> }
	object { Pilier_0 translate <-EX, 0, EZ> }
	object { Pilier_0 translate < EX, 0,-EZ> }
	object { Pilier_0 translate < EX, 0, EZ> }
	/* interieur sur l'axe des Z */
	#local EX = Ouv_X + 0.62;		// XXX 6.57;
	#local EZ = Z_lustre;
	object { Pilier_0 translate <-EX, 0,-EZ> }
	object { Pilier_0 translate <-EX, 0, EZ> }
	object { Pilier_0 translate < EX, 0,-EZ> }
	object { Pilier_0 translate < EX, 0, EZ> }
	}
}

/*    ======================================================    */

#declare Les_colonnes = object
{
union	{
	#local ExA  = dX_cc_coin;
	#local EzA  = dZ_cc_coin;
	object { ColCoin  translate <-ExA, 0,  -EzA> }
	object { ColCoin  translate < ExA, 0,  -EzA> }
	object { ColCoin  translate <-ExA, 0,   EzA> }
	object { ColCoin  translate < ExA, 0,   EzA> }

	#local ExB  = Sz_X - 4.60;
	#local EzB  = 4.40;
	object { ColRonde translate <-ExB, 0,   EzB> }
	object { ColRonde translate <-ExB, 0,  -EzB> }
	object { ColRonde translate < ExB, 0,  -EzB> }
	object { ColRonde translate < ExB, 0,   EzB> }
	}
}

/*    ======================================================    */
/*
 *	habillage du toit
 */
#declare Traverse_Toit_0 = object
{
#local Ex = Ouv_X + 1.60;
#local Ez = E_mur * 0.42;
#local Sa = 0.33;
#local Sb = 0.51;
merge {
	box { <-Sa, 0, -Sb>, <Sa, 0.30, Sb> translate -x*Ex }
	box { <-Ex, 0.15, -Ez>, <Ex, E_mur+0.15, Ez> }
	box { <-0.3, 0, -0.3>, <0.3, 0.30, 0.3> translate  x*Ex }
	}
texture { MON_VERT_INDUS scale 0.301 }
#undef Ex
#undef Ez
#undef Sb
#undef Sa
}

/*    ======================================================    */
/*    ------------------------------------------------------    */
/*
		ALORS VOILÀ...
		cet élément fondateur de cette scène va prendre
		quelques semaines (ou mois ?) de congé, avant de
		revenir sous une autre forme...

#local DS = 21.00;
#include "WS/picz.inc"

#declare Picz_3D = object
{
#local S = 0.0008;
object { picz scale <S, S*16.00, S> }
texture {
	pigment { color rgb <0.876, 0.424, 0.1504>  }
	finish { phong PHONG specular SPECULAR }
	}
rotate 180*z
translate <NormClock*0.300, NormClock*12.25, NormClock>
}

		Stay tuned, film at 11.
*/
/*    ======================================================    */
/*
 *	inside ground 
 */
#declare Plancher_0 = object
{
box {		<-(Sz_X+E_mur), 0,	-(Sz_Z+E_mur)>,
		< (Sz_X+E_mur), 0.004,	(Sz_Z+E_mur)>		}
texture {
	pigment {
		image_map { png "Nimages/hexagone.png"  }
		rotate x*90
		scale 1.90
		}

	scale 1.53
	rotate <29, 33.333, 26>
	finish { reflection 0.036 }
	}
}
/*    ======================================================    */

#declare Des_Exposants_A = object
{
#local Ke = 5.15;
union	{
	object { La_BoiteBloub		translate <-0.90, 0, -5.75*Ke> }

	object { Les_Spirales		translate <0, 0, -4.5*Ke> }
	// object { Lampe_Cube	rotate -z*20	translate <1.6, 3.5, -4.5*Ke> }

	object { Le_Machin_6 rotate y*4 translate <-1.0, 0, -3.5*Ke> }

	object { La_Structure		translate <-0.40, 0, -2.6*Ke> }

	object { Le_Machin_Disques	translate <-0.95, 0, -1.74*Ke>	}

	#if (mod(clock, 37) > 11)
	  #local Couleur = Green  * 0.70;
	#else
	  #local Couleur = Yellow * 0.90;
	#end
	// object { Lampe_Cube_2(Couleur)	rotate z*33 translate <-2.9, 4.8, 2.64*Ke> }
	object { Le_Encore_Un_Truc	rotate 7*y translate <-0.25, 0,  2.0*Ke> }

	object { Le_Cube_Bulles 	translate <-0.8, 0,    3.37*Ke> }
	// object { Lampe_Cube	rotate -z*18	translate < 1.2, 3.5,  4.12*Ke> }

	object { La_RotoMachine	rotate y*3	translate < 0, 0,  4.37*Ke> }
	}
#undef Ke
}
/*    ======================================================    */

#local Ke = 2.95;		// ecart des machins
#local Kf = Ke+1.15;		// taille du socle
#local Kh = 0.28;		// hauteur du socle
#local Kr = Ke * 0.71;		// rayon decoupe

#declare Socle_Exposants_B = object
{
difference {
	box { <-Kf, 0, -Kf>, <Kf, Kh, Kf> 	}
	cylinder { <0, -1, 0>, <0, 1, 0>, Kr translate <-Kf, 0, -Kf> 	}
	cylinder { <0, -1, 0>, <0, 1, 0>, Kr translate < Kf, 0, -Kf> 	}
	cylinder { <0, -1, 0>, <0, 1, 0>, Kr translate <-Kf, 0,  Kf> 	}
	cylinder { <0, -1, 0>, <0, 1, 0>, Kr translate < Kf, 0,  Kf> 	}
	}
texture { T_Stone20 rotate x*45 scale 1.85 }
}

#declare Des_Exposants_B = object
{
union	{
	object { Socle_Exposants_B					}
	object { Stand_MultiTore rotate y*10 translate <-Ke, Kh,   0>	}
	object { TextureLab             translate < Ke, Kh,   0>	}
	object { The_Bouncer		translate y*Kh			}
	object { Le_Plateau_Oscillant   translate <  0, Kh, -Ke>	}
	object { Le_Champ_Altitude      translate <  0, Kh,  Ke>	}

	object { Quadri_Kiosque		rotate y*45			}
	#local EL = 1.3;
	object { Lampe_Boule_Rouge	translate <  EL,  5.3,   EL>	}
	object { Lampe_Boule_Verte	translate < -1.2,  5.3,   1.2>	}
	object { Lampe_Boule_Verte	translate <  1.2,  5.3,  -1.2>	}
	object { Lampe_Boule_Rouge	translate < -1.2,  5.3,  -1.2>	}
	}
}
#undef Ke

/*    ======================================================    */
#local Base_anneau_chaise = object
{
cone { <0, 0, 0>, 2.80, <0, 0.10, 0> , 2.60 }

texture {
	pigment {
		DMFWood4       // pre-defined in textures.inc
		scale 2.50     // scale by the same amount in all
                	       // directions
      		}
	finish { Shiny } // pre-defined in finish.inc
	}
}
#local Anneau_chaine = object
{
union	{
	object { Cercle_de_chaises }
	object { Premier_Anneau    }
	object { Spot rotate y*176 translate 3.90*z }
	}
}

#declare Anneau_et_chaises = object
{
union	{
	object { Base_anneau_chaise }
	object { Anneau_chaine  translate y*0.10  }
	}
}
/*    ======================================================    */
#declare Stele_A_et_Spot_2 = object		/* new 27 avril 2022 */
{
union	{
	object { Stele_A rotate 90*y }
	#local Rya = 82 + 11.92 * sin(NormClock * 209);
	#local Ryb = 98 +  9.44 * sin(NormClock * 173);
	object { Lampe_Spot_2 rotate <27, Rya, 0> translate <3.40, 0.75, -0.85> }
	object { Lampe_Spot_2 rotate <19, Ryb, 0> translate <3.30, 0.75,  0.85> }
	}

}
/*    ======================================================    */
#declare Stele_B_et_Spot_2 = object		/* new 27 avril 2022 */
{
union	{
	object { Stele_B rotate -90*y }
	#local Rya = -82 +  9.72 * sin(NormClock * 181);
	#local Ryb = -98 + 11.44 * sin(NormClock * 203);
	object { Lampe_Spot_2  rotate <19, Rya, 0> translate <-3.50, 0.75, -0.81> }
	object { Lampe_Spot_2  rotate <13, Ryb, 0> translate <-3.60, 0.75,  0.85> }
	}

}
/*    ======================================================    */

#local HCB = 0.33;
#local RCB = 3.80;
#local Base_Coin_Bouffe = object
{
difference {
	cylinder { <0, 0, 0>, <0, HCB, 0>, RCB }
	torus { RCB, 0.10  translate y*(HCB+0.03) }
	box { <-1.40, HCB/2, -2.70>, <1.40, 1, -4.00> }
	}
texture { ROSE_BIZARRE scale 8.34 }
}
#declare Coin_bouffe_barriere = object
{
/* new 29 avril 2022 */
union	{
	object { Base_Coin_Bouffe }
	object { Le_Coin_Bouffe  translate y*HCB   }
	object { Cercle_Barriere_2	rotate y*225	translate y*HCB }
	object { LampeResto		rotate -y*18	translate y*HCB	}
	}
}
#undef HCB
#undef RCB
/*    ======================================================    */
#declare Espace_Cinema = object
{
// on va essayer de regrouper les trucs devant la rotonde
// nouveau 20 oct 2022 : les barrieres

#local SX = 5.20;
#local SZ = 5.00;
union	{
	box { <-SX, 0, -SZ>, <SX, 0.10, SZ> texture
				{ T_Wood35 rotate 11 scale 2 }  }
	object { Rang_Barriere_4 translate <-(SX-0.17), 0.10, 0> }
	object { Rang_Barriere_4 translate < (SX-0.15), 0.10, 0> }
	object { Rang_Barriere_4 rotate y*90 translate < 0.35, 0.10, SZ-0.22> }
	object { Un_Tabouret(Blue) rotate y*12 translate <-4.15, 0.10, 2.95> }
	object { Gueridon_0  translate <-3.00, 0.10, 2.80> }
	}
#undef SX
#undef SZ
}

/*    ======================================================    */
/*
 *        encore en chantier
 */
#declare Clochetons_du_toit = object
{
#local EX = dX_cc_coin;
#local EY = Sz_Y + E_mur;
#local EZ = dZ_cc_coin;
union	{
	object { Balise_Grise scale 2 translate <-EX, EY, -EZ> }
	object { Balise_Grise scale 2 translate < EX, EY, -EZ> }
	object { Balise_Grise scale 2 translate <-EX, EY,  EZ> }
	object { Balise_Grise scale 2 translate < EX, EY,  EZ> }
	}
}
/*    ======================================================    */
/*
 *		ASSEMBLAGE FINAL DU BATIMENT PRINCIPAL
 *
 */
#declare Batiment_Complet = object
{
union	{
	#if (ShowWall)
	  object { Batiment }
	#end

	#if (ShowWall)
	 #local H_trav = Sz_Y + E_mur + 0.01;
	 object { Traverse_Toit_0 translate <0, H_trav, -Z_cubes>   }
	 object { Traverse_Toit_0 translate <0, H_trav, -Z_lustre> }
	 object { Traverse_Toit_0 translate <0, H_trav,  Z_cubes>   }
	 object { Traverse_Toit_0 translate <0, H_trav,  Z_lustre> }

	  object { Clochetons_du_toit }
	#end
	
	object { Lustre_A   translate <0, Y_lustre,  Z_lustre> }
	object { Lustre_B   translate <0, Y_lustre, -Z_lustre> }
	object { Plancher_0 }
	// object { Frise_A translate <-5.85, Sz_Y+E_mur, 0> }
	// object { Frise_A translate < 5.85, Sz_Y+E_mur, 0> }
	object { Les_colonnes }
	object { Les_Piliers }
	object { Stele_A_et_Spot_2 translate <-(Sz_X-0.30), 0, -18.40> }
	object { Stele_B_et_Spot_2 translate <  Sz_X-0.30,  0,  17.00> }

	object { Le_Machin_en_bois translate <Sz_X*0.56, 0, Sz_Z*0.58> }

	object { Espace_Cinema 			translate <0, 0, -(Sz_Z-5.00)> }

	object { Coin_bouffe_barriere	translate <7.10, 0, -(Sz_Z-14.00)> }
	object { Le_Mecanisme		translate <-7.30, 0, -(Sz_Z-14.30)> }

	object { Fake_Monster rotate y*45.11 translate <0.03, 0,  0.05>}

	object { Anneau_et_chaises  translate < 17.17,  0,  -(Sz_Z*0.60)> }

	object { Le_Coin_Craignos translate <-(Sz_X-3.10), 0, (Sz_Z-12.30)> }

	object { Des_Exposants_A translate -x*(Sz_X*0.58) }
	object { Des_Exposants_B rotate y*57 translate <0.85, 0, Sz_Z-13.80> }

	/* --------------- les trucs dans les quatres coins ----- */
	#local E4C = 2.75;
	object { Le_Machin_Gelule         translate <-(Sz_X-E4C), 0, -(Sz_Z-E4C)> }
	object { Le_Fuseau_en_Pierre      translate < (Sz_X-E4C), 0, -(Sz_Z-E4C)> }
	object { Le_PentaTube  rotate y*5 translate <-(Sz_X-E4C), 0,  (Sz_Z-E4C)> }
	object { Le_Machin_3              translate < (Sz_X-E4C), 0,  (Sz_Z-E4C)> }
	// nouveau 10 avril 2022
	#local EL0 = 6.19;
	object { Lampe_V0 rotate  45*y translate < (Sz_X-EL0), 0,  (Sz_Z-EL0)> }
	object { Lampe_V0 rotate 135*y translate < (Sz_X-EL0), 0, -(Sz_Z-EL0)> }
	object { Lampe_V0 rotate -45*y translate <-(Sz_X-EL0), 0,  (Sz_Z-EL0)> }
	object { Lampe_V0 rotate 225*y translate <-(Sz_X-EL0), 0, -(Sz_Z-EL0)> }
	/* ---------------                                pan(s) */

	object { La_Julia      rotate -y*18 translate <-4.75, 0, Sz_Z-6.55> }
	object { Lentille_Divergente
			rotate y*165 translate <-5.55, 0, Sz_Z-4.85> }

	object { Les_Heptacles rotate  y*12 translate < 4.80, 0, Sz_Z-6.05> }

	object { Le_Machin_neuf_barres  translate <Sz_X-2.85, 0,  -Sz_Z*0.70>}

	object { Petit_Banc(Magenta) rotate y*92
					translate <8.30, 0, -(Sz_Z-0.53)> }
	object { Petit_Banc(IndianRed)
				translate <-(Sz_X-0.90), 0, -4.2> }
	object { Un_Tabouret(GreenCopper) // scale 10
				translate <-(Sz_X-1.20), 0, 2.6> }

	object { Chaise_Grise rotate 130*y translate  <Sz_X-11.20, 0, Sz_Z-1.83> }
	object { Chaise_Jaune rotate 175*y translate  <Sz_X-7.20,  0, Sz_Z-0.64> }
	object { Chaise_Jaune rotate 188*y translate  <Sz_X-6.20,  0, Sz_Z-0.67> }
	object { Chaise_Jaune rotate 180*y translate  <Sz_X-5.20,  0, Sz_Z-0.74> }

	/* place pour l'objet complexe */
	union	{
		object { La_Chose_Complexe rotate y*12 }
		#if (rand(RND) < NormClock)
		  object { Lampe_Boule_Bleu  translate <0.09, 3.45, 0.10>  }
		#else
		  object { Lampe_Boule_Rouge translate <0.09, 3.45, 0.10>  }
		#end
		translate <14.44, 0, -10.60>
		}

	object { La_BouncingBall 	rotate 12*y
					translate < Sz_X-3.40, 0, -14.80>		}

	object { Le_Champi		translate <12.95, 0, 13.40> }
	object { Lentille_Convergente 	translate <13.37, 0, 14.95> }

	object {  Le_Parametric_A	rotate -67*y
					translate <-10.54, 0, Sz_Z-10.50> }

	object { Le_Machin_7 rotate y*9	translate <12.20, 0, -(Sz_Z-5.60)> }

	object { Le_Machin_Spiraleux  		translate <18.62, 0, 23.45> }

	object { Table_Haute_Deux_Bancs		translate <16.55, 0,  9.79> } 
	object { Table_Basse_Deux_Bancs rotate y*78
				translate <8.25, 0,  Sz_Z-8.83> }

	object { Miroir_qui_tourne  translate <-6.35, 0, Sz_Z*0.53> }


	/*
	 *		les trucs en hauteur
	 */
	#local H_cubes = Sz_Y-2.15;
	object { PsychoCube	rotate -y*(clock*1.06)
				translate  < 4.40, H_cubes,  -Z_cubes> }
	object { Cube_Lumiere	rotate  -y*(clock*0.79)
				translate  <-4.30, H_cubes, -Z_cubes> }
	object { Cube_Lumiere	rotate  y*(clock*0.75)
				translate  < 4.60, H_cubes,  Z_cubes> }
	object { Gravity_Cube	rotate  y*(clock*0.71)
				translate  <-3.90, H_cubes,  Z_cubes> }


	/* l'image de la scene dans le futur d'avant */
	object { Panneau_0 
		rotate <-90, -90, 0>
		translate <-(Sz_X-0.30), 3.42, 11.25>
		}

	object { Signature scale 0.666
		rotate -90*y translate <-(Sz_X-0.70), 4.90, 1.00> }

	object { Letters_tTh
		scale 2.25 rotate y*180 translate <0, Sz_Y-2.50, Sz_Z+1.95>
		texture {
			pigment { color Yellow }
			finish { ambient .35 phong .65 }
			}
		}

	object { Le_Grand_Titre scale 1.15
		// rotate y*180
		translate <-4.22, Sz_Y*0.680, (Sz_Z - 0.99)> }

	object { Slogan_Rotonde scale 1.15
		rotate y*180
		translate <-0, Sz_Y*0.55, -(Sz_Z - 0.45)> }

	object { Film_Roulotte
		rotate <-87, -90, 0>
		translate < (Sz_X-0.30), 3.25, -12.50>
		}

	}
}
/*    ------------------------------------------------------    */
